package cn.com.qmth.stmms.biz.report.utils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectCollege;
import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 课程电厂分析
 *
 */
public class ReportSubjectCollegeDTO {

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    private String subjectName;

    /**
     * 电厂名称
     */
    @ExcelField(title = "电厂", align = 2, sort = 30)
    private String collegeName;

    /**
     * 最高分
     */
    @ExcelField(title = "最高分", align = 2, sort = 40)
    private String maxScore;

    /**
     * 最低分
     */
    @ExcelField(title = "最低分", align = 2, sort = 50)
    private String minScore;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 60)
    private String avgScore;

    /**
     * 及格率
     */
    @ExcelField(title = "及格率", align = 2, sort = 70)
    private String passRate;

    /**
     * 及格数
     */
    @ExcelField(title = "及格人数", align = 2, sort = 80)
    private Integer passCount;

    /**
     * 优秀率
     */
    @ExcelField(title = "优秀率", align = 2, sort = 90)
    private String excellentRate;

    /**
     * 优秀人数
     */
    @ExcelField(title = "优秀人数", align = 2, sort = 100)
    private Integer excellentCount;

    /**
     * 报考人数
     */
    @ExcelField(title = "报考人数", align = 2, sort = 110)
    private Integer totalCount;

    /**
     * 有效人数
     */
    @ExcelField(title = "有效人数", align = 2, sort = 120)
    private Integer realityCount;

    public ReportSubjectCollegeDTO(ReportSubjectCollege r) {
        DecimalFormat format = new DecimalFormat("0.00");
        this.subjectCode = r.getSubjectCode();
        this.subjectName = r.getSubjectName();
        this.collegeName = r.getCollegeName();
        this.maxScore = format.format(new BigDecimal(r.getMaxScore()).setScale(2, RoundingMode.HALF_UP).doubleValue()).toString();
        this.minScore = format.format(new BigDecimal(r.getMinScore()).setScale(2, RoundingMode.HALF_UP).doubleValue()).toString();
        this.avgScore = format.format(new BigDecimal(r.getAvgScore()).setScale(2, RoundingMode.HALF_UP).doubleValue()).toString();
        this.passRate = format.format(new BigDecimal(r.getPassRate()).setScale(2, RoundingMode.HALF_UP).doubleValue()).toString();
        this.excellentRate = format.format(new BigDecimal(r.getExcellentRate()).setScale(2, RoundingMode.HALF_UP).doubleValue()).toString();
        this.passCount = r.getPassCount();
        this.excellentCount = r.getExcellentCount();
        this.realityCount = r.getRealityCount();
        this.totalCount = r.getTotalCount();
    }
}